// compile: gcc -Wall OperatorOverloading-C.c -o OperatorOverloading-C

#include <stdio.h>

typedef struct Object {
  float x;
} Object;

void Object_init  (Object *this, const float x) { this->x = x; }
void Object_deinit(Object *this)                { }

void Object_set(Object *const this, const Object *const x) { this->x = x->x; }

void Object_mult(Object *z, const Object *x,const Object *const y) { z->x = x->x*y->x; }
void Object_plus(Object *z, const Object *x,const Object *const y) { z->x = x->x+y->x; }

void Object_print(const Object *const this) { printf("%g\n",this->x); }


int main() {
  Object x;  Object_init(&x,2.1);
  Object y;  Object_init(&y,4.2);
  Object z;  Object_init(&z,5.1);

  // *** FILL ME IN *** (do x+y+z and print the results)
  Object t1;
  Object t2;
  Object_plus(...);
  Object_plus(...);
  Object_print(...);

  return 0;
}
